// For comparing timelines
function drawTimelines(contact) {
	contacts = jQuery.parseJSON(contact);
	fillColorTable();
	drawComparingVisualization();

}
function drawComparingVisualization() {

	data = new google.visualization.DataTable();
	data.addColumn('datetime', 'start');
	data.addColumn('datetime', 'end');
	data.addColumn('string', 'content');
	data.addColumn('string', 'group');
	data.addColumn('string', 'className');
	data.addColumn('string', 'service');
	data.addColumn('string', 'serviceGroup');
	data.addColumn('string', 'diagnoseGroup');

	// load data and create the timeline here
	for (var i = 0; i < contacts.length; i++) {
		if (contacts[i].startDate === contacts[i].endDate) {
			
			data.addRow([
					new Date(contacts[i].startDate),
					,
					,
					contacts[i].diagnoseGroupName, 
					"group" + contacts[i].diagnoseGroup + " "
							+ checkStrokeDiganose(contacts[i]) + " id" + i,
					contacts[i].service, contacts[i].serviceGroup,
					contacts[i].diagnoseGroupName ]);
		} else {
			data.addRow([
					new Date(contacts[i].startDate),
					new Date(contacts[i].endDate),
					,
					contacts[i].diagnoseGroupName,
					"group" + contacts[i].diagnoseGroup + " "
							+ checkStrokeDiganose(contacts[i]) + " id" + i,
					contacts[i].service, contacts[i].serviceGroup,
					contacts[i].diagnoseGroupName ]);
		}
	}
	var strokeDebut = findStrokeDebut();
	for (var i = 0, maxrows = data.getNumberOfRows(); i < maxrows; i++) {
		if(strokeDebut>new Date(contacts[i].startDate)) {
			data.setValue(i, 4, data.getValue(i, 4) + " strokeDebut");
		}
	}
	// Instantiate the timeline object.
	timeline = new links.Timeline(document.getElementById('timeline'), options);
	timeline.setCustomTime(strokeDebut);

	compareTimelines();
	setToolTip();
}

//Switch between different options
function compareTimelines() {
	var sorting;
	if(document.getElementById('j_idt22:comparing:0').checked) {
		sorting=6;
	} else {
		sorting=7;
	} 
	for (var i = 0, maxrows = data.getNumberOfRows(); i < maxrows; i++) {
		data.setValue(i, 3, data.getValue(i, sorting));
	}
	timeline.draw(data);
	if(document.getElementById('j_idt22:comparing:1').checked) {
		setBackgroundColor();
	}
	if (document.getElementById('j_idt22:comparing:2').checked) {
		if(document.getElementById('j_idt22:comparing:3').checked) {
			$('.nostroke').css({
				opacity : 0.3
			});
		} else{
			$('.nostroke').css({
				opacity : 1
			});
		}
		$('.strokeDebut').css({
			opacity : 0
		});
	} else {
		$('.strokeDebut').css({
			opacity : 1
		});

		if(document.getElementById('j_idt22:comparing:3').checked) {
			$('.nostroke').css({
				opacity : 0.3
			});
		} else{
			$('.nostroke').css({
				opacity : 1
			});
		} 
	}
}