var timeline;
var contacts; // list of contacts for current PID
var onlyStroke;
google.load('visualization', '1');
//google.setOnLoadCallback(drawVisualization); //visualization function

var DAY_IN_MILLISECONDS = 86400000;
var MONTH_IN_MILLISECONDS = DAY_IN_MILLISECONDS * 28;
var QUARTER_IN_MILLISECONDS = MONTH_IN_MILLISECONDS * 4;

//var minDate = new Date(2010, 2, 7);
//var minDate = new Date(0000, 2, 7);
//minDate.setFullYear(minDate.getFullYear() - 1900);
//var maxDate = new Date(00, 2, 7);
var minDate = new Date(2010, 2, 7);
//minDate.setFullYear(minDate.getFullYear() - 1900);
var maxDate = new Date(2012, 2, 7);

var data;

var selectedContact;
var selectedContactClasses;

var colors;


var options = {
		// localization
		'locale' : 'no',
		// layout
		'width' : '100%',
		// 'height' : '43px',
		// 'minHeight' : '500px',
		'showCurrentTime' : false,
		'showCustomTime' : true,
		'axisOnTop' : true,
		'eventMargin' : -15, // minimal margin between events
		'eventMarginAxis' : 0, // minimal margin between events and the axis
		// default event style
		'style' : 'box',
		'stackEvents' : false,
		'showMinorLabels' : true,
		'showMajorLabels' : true,
		// interaction
		'selectable' : false,
		'editable' : false,
		// time
		'zoomMin' : DAY_IN_MILLISECONDS,
		'min' : minDate,
//		'max' : maxDate,
//		'start' : minDate,
//		'end' : maxDate,
		'locale' : 'no',
		'groupMinHeight' : 50,
		'showNavigation': true
	};
/**
 * set mindate and maxdate for timeline based on events. This function will take
 * the earliest date as mindate, the most resent date as maxdate,
 * 
 * @returns {undefined}
 */

function setTimelineDates() {
	if (contacts.length > 0) {
		var firstdate = new Date(contacts[0].startDate);
		var lastdate = new Date(contacts[0].endDate);
		for (var i = 0; i < contacts.length; i++) {
			if (firstdate > new Date(contacts[i].startDate)) {
				firstdate = new Date(contacts[i].startDate);
			}
			if (lastdate < new Date(contacts[i].endDate)) {
				lastdate = new Date(contacts[i].endDate);
			}
		}
		var days = 30;
		// minDate = new Date(firstdate.getTime() - days * DAY_IN_MILLISECONDS);
//		minDate = new Date(2010, 2, 1);
		maxDate = new Date(lastdate.getTime() + days * DAY_IN_MILLISECONDS);
//		maxDate.setFullYear(maxDate.getFullYear()-2010);
//		maxDate = new Date(2012, 5, 1);
//		options.end = maxDate;
		options.max = maxDate;
//		options.start = minDate;
	}
}


//function drawTimeline(patient) {
//	contacts = jQuery.parseJSON(patient);
//	fillColorTable();
//	setTimelineDates();
//	drawVisualization();
//}

function drawTimeline(patient) {
	contacts = getAnonPatient(patient);
	fillColorTable();
	setTimelineDates();
	drawVisualization();
}

function drawVisualization() {
	data = new google.visualization.DataTable();
	data.addColumn('datetime', 'start');
	data.addColumn('datetime', 'end');
	data.addColumn('string', 'content');
	data.addColumn('string', 'group');
	data.addColumn('string', 'className');
	data.addColumn('string', 'service');
	data.addColumn('string', 'serviceGroup');
	data.addColumn('string', 'diagnoseGroup');

	// load data and create the timeline here
	for (var i = 0; i < contacts.length; i++) {
		if (contacts[i].startDate === contacts[i].endDate) {
			var date = new Date(contacts[i].startDate);
//			date.setFullYear(date.getFullYear()-2010);
			data.addRow([
					date,
					,
					,
					contacts[i].diagnoseGroupName, 
					"group" + contacts[i].diagnoseGroup + " "
							+ checkStrokeDiganose(contacts[i]) + " id" + i,
					contacts[i].service, contacts[i].serviceGroup,
					contacts[i].diagnoseGroupName ]);
		} else {
			var startDate = new Date(contacts[i].startDate);
//			startDate.setFullYear(startDate.getFullYear()-2010);
			var endDate = new Date(contacts[i].endDate);
//			endDate.setFullYear(endDate.getFullYear()-2010);
			data.addRow([
					startDate,
					endDate,
					,
					contacts[i].diagnoseGroupName,
					"group" + contacts[i].diagnoseGroup + " "
							+ checkStrokeDiganose(contacts[i]) + " id" + i,
					contacts[i].service, contacts[i].serviceGroup,
					contacts[i].diagnoseGroupName ]);
		}
	}
	// Instantiate the timeline object.
	timeline = new links.Timeline(document.getElementById('timeline'), options);
	timeline.setCustomTime(findStrokeDebut());
	changeGrouping();
	// Add event listeners
//	google.visualization.events.addListener(timeline, 'select', onselect);
	
	// Draw the timeline with the created data and options
	timeline.draw(data);
	setBackgroundColor();
	strokeDiagnose();
	colorDescription()
	setToolTip();
}

// Checks if the contact is related to stroke
function checkStrokeDiganose(contact) {
	if (contact.stroke == -1) {
		return "unknown";
	} else if (contact.stroke == 0) {
		return "nostroke";
	} else if (contact.stroke == 1) {
		return "stroke";
	}
	return "unknown";
}

function findStrokeDebut() {
	for (var i = 0; i < contacts.length; i++) {
		if (contacts[i].stroke == 1) {
			var date = new Date(contacts[i].startDate);
//			date.setFullYear(date.getFullYear()-2010);
			return date;
		}
	}
}

// Hides contacts not related to stroke
function strokeDiagnose() {
	if ($('input[name=stroke]:checked').val()=="stroke1") {
		// marked contacts
		$('.nostroke').css({
			'backgroundColor': 'rgba(0,0,0,0)'
		});
		// unmarked contacts
		for(var i=0;i<contacts.length;i++) {
			if(contacts[i].stroke==-1 && new Date(contacts[i].startDate)<findStrokeDebut()) {
				$('.id'+i).css({
					'backgroundColor': 'rgba(0,0,0,0)'
				});
			}
		}
		colorDescription();
	} else {
		setBackgroundColor();
		colorDescription();
	}
	
}

// Change the grouping between diagnose and service
function changeGrouping() {
	if ($('input[name=grouping]:checked').val()=="grouping2") {
		for (var i = 0, maxrows = data.getNumberOfRows(); i < maxrows; i++) {
			data.setValue(i, 3, data.getValue(i, 6));
		}
	} else {
		for (var i = 0, maxrows = data.getNumberOfRows(); i < maxrows; i++) {
			data.setValue(i, 3, data.getValue(i, 7));
		}
	}
	timeline.draw(data);
}



function updateTimeline() {
	changeGrouping();
	timeline.draw(data);
	setBackgroundColor();
	strokeDiagnose();
	setToolTip();
}

function formatDate(date) {
	var monthNames = [ "januar", "februar", "mars",
	                  "april", "mai", "juni", "juli",
	                  "august", "september", "oktober",
	                  "november", "desember" ];
	return new Date(date).getDate() + ". " + monthNames[new Date(date).getMonth()] + " " + new Date(date).getFullYear();
}

// Tooltip
function setToolTip() {
	for(var i=0;i<contacts.length;i++) {
		$( ".id"+i ).tooltip();
		$( ".id"+i ).prop('title', contacts[i].service);
		$( ".id"+i ).tooltip({
			  content: getTooltipText(i)
		}).css({
			'fontSize' : '20px' // er dette riktig? Nei...
		});
	}
}

function changeClusterContactsShape() {
	$('.groupclusterContact').css({
		'borderRadius': '2px',
		'backgroundColor': 'rgba(0,0,0,0.1)',
		'borderColor': 'rgba(0,0,0,1)',
		'borderStyle': 'dashed'
	});
	$('.groupSPF').css({
		'borderStyle': 'dashed',
//		'borderRadius': '2px',
	})
}
function getTooltipText(i) {
	var string = "<b>" + contacts[i].service + " </b><br/>";
	
	if(contacts[i].startDate != contacts[i].endDate) {
		string += "Start: " + formatDate(contacts[i].startDate) + " <br>";
		string += "Slutt: " + formatDate(contacts[i].endDate) + " <br>";
	} else {
		string += "Dato: " + formatDate(contacts[i].startDate) + " <br>";
	}
	if(contacts[i].serviceGroup==" *Slag SPF*") {
		if(contacts[i].service=="Varsel") {
//			string += 'Forklaring...<br/>';
		} else if(contacts[i].service=="Behandling") {
//			string += 'Forklaring...<br/>';
		} else if(contacts[i].service=="Rehabilitering") {
//			string += 'Forklaring...<br/>';
		}
	} else {
		string += "Tjenestegruppe: " + contacts[i].serviceGroup + " <br>";
		if(contacts[i].service=="Typisk slagkontakt") {
			var percent = (contacts[i].extInfo*100).toFixed(2);
//			string += 'Forklaring...<br/>';
			string += 'Sannsynlighet: ' + percent + ' %<br>';
		} else {
			string += "Diagnosegruppe: "+ contacts[i].diagnoseGroupName + " <br>";			
		}
	}

	return string;
}

// Color the events in the timeline
function setBackgroundColor() {
	for (var c = 0; c < contacts.length; c++) {
		var group = "group" + contacts[c].diagnoseGroup;
		var groupName = "" + contacts[c].diagnoseGroupName;
		var i = 0;
		var done = false;
		if(contacts[c].diagnoseGroup === "noGroup") {
			$('.' + group).css({
				borderColor : colors.getValue(0, 0),
				backgroundColor : colors.getValue(0, 1)
			});
			colors.setValue(0, 2, group);
			colors.setValue(0, 3, groupName);
			done = true;
		} else if (contacts[c].diagnoseGroup == "SPF") {
			$('.' + group).css({
				borderColor : colors.getValue(1, 0),
				backgroundColor : colors.getValue(1, 1)
			});
			colors.setValue(1, 2, group);
			colors.setValue(1, 3, groupName);
			done = true;
		} else if (contacts[c].diagnoseGroup == "clusterContact"){
		} else {
			while (i < colors.getNumberOfRows() && !done) {
				if (colors.getValue(i, 2) == group || colors.getValue(i, 2) == undefined) {
					$('.' + group).css({
						borderColor : colors.getValue(i, 0),
						backgroundColor : colors.getValue(i, 1)
					});
					colors.setValue(i, 2, group);
					colors.setValue(i, 3, groupName);
					done = true;
				}
				i++;
			}
		}
	}
	changeClusterContactsShape();
}

// Creates a list of contrasting colors
function fillColorTable() {
	colors = new google.visualization.DataTable();
	colors.addColumn('string', 'color');
	colors.addColumn('string', 'opacityColor');
	colors.addColumn('string', 'diagnoseGroup');
	colors.addColumn('string', 'diagnoseGroupName');
	var opacity = 0.7;
	colors
			.addRows([
					[ 'rgb(128, 128, 128)', 'rgba(128, 128, 128, ' + opacity + ')', undefined, undefined ], // I - no Diagnose
					[ 'rgb(255, 164, 5)', 'rgba(255, 164, 5, 0.2)', undefined, undefined ], // O - SPF
					[ 'rgb(255, 80, 5)', 'rgba(255, 80, 5, ' + opacity + ')', undefined, undefined ], // Z
					[ 'rgb(116, 10, 255)', 'rgba(116, 10, 255, ' + opacity + ')', undefined, undefined ], // V
					[ 'rgb(194, 0, 136)', 'rgba(194, 0, 136, ' + opacity + ')', undefined, undefined ], // M
					[ 'rgb(0, 92, 49)', 'rgba(0, 92, 49, ' + opacity + ')', undefined, undefined ], // F
					[ 'rgb(157, 204, 0)', 'rgba(157, 204, 0, ' + opacity + ')', undefined, undefined ], // L
					[ 'rgb(255, 168, 187)', 'rgba(255, 168, 187, ' + opacity + ')', undefined, undefined ], // P
					[ 'rgb(94, 241, 242)', 'rgba(94, 241, 242, ' + opacity + ')', undefined, undefined ], // S
					[ 'rgb(240, 163, 255)', 'rgba(240, 163, 255, ' + opacity + ')', undefined, undefined ], // A - start others
					[ 'rgb(0, 117, 220)', 'rgba(0, 117, 220, ' + opacity + ')', undefined, undefined ], // B
					[ 'rgb(0, 51, 128)', 'rgba(0, 51, 128, ' + opacity + ')', undefined, undefined ], // N
					[ 'rgb(255, 0, 16)', 'rgba(255, 0, 16, ' + opacity + ')', undefined, undefined ], // R
					[ 'rgb(0, 153, 143)', 'rgba(0, 153, 143, ' + opacity + ')', undefined, undefined ], // T
					[ 'rgb(224, 255, 102)', 'rgba(224, 255, 102, ' + opacity + ')', undefined, undefined ], // U
					[ 'rgb(153, 0, 0)', 'rgba(153, 0, 0, ' + opacity + ')', undefined, undefined ], // W
					[ 'rgb(255, 255, 128)', 'rgba(255, 255, 128, ' + opacity + ')', undefined, undefined ], // X
					[ 'rgb(255, 255, 0)', 'rgba(255, 255, 0, ' + opacity + ')', undefined, undefined ], // Y
					[ 'rgb(148, 255, 181)', 'rgba(148, 255, 181, ' + opacity + ')', undefined, undefined ], // J
					[ 'rgb(225, 204, 153)', 'rgba(225, 204, 153, ' + opacity + ')', undefined, undefined ], // H
					[ 'rgb(143, 124, 0)', 'rgba(143, 124, 0, ' + opacity + ')', undefined, undefined ], // K
					[ 'rgb(76, 0, 92)', 'rgba(76, 0, 92, ' + opacity + ')', undefined, undefined ], // D
					[ 'rgb(25, 25, 25)', 'rgba(25, 25, 25, ' + opacity + ')', undefined, undefined ], // E
					[ 'rgb(153, 63, 0)', 'rgba(153, 63, 0, ' + opacity + ')', undefined, undefined ], // C
					[ 'rgb(43, 26, 72)', 'rgba(43, 26, 72, ' + opacity + ')', undefined, undefined ], // G
					[ 'rgb(66, 102, 0)', 'rgba(66, 102, 0, ' + opacity + ')', undefined, undefined ], // Q
			]);
}

// Makes the color anf figure descripton for the timeline contacts
function colorDescription() {
	$('#color').empty();
	$('#color').append('<h4>Fargeforklaring:</h4>');
	var table = $('<table></table>');
	for (var i=0;i<colors.getNumberOfRows();) {
		if(colors.getValue(i, 2) != undefined) {
			var row = $('<tr></tr>') 
			for(var j=0;j<3;i++) {
				if(colors.getValue(i, 3) != 'undefined' && colors.getValue(i, 3) != " Standard slagforløp") {
					if(colors.getValue(i, 2) != undefined) {
						var column = $('<td></td>');
						$('<span id=circle></span>').css({'background': colors.getValue(i, 1), 'border': '1px solid ' + colors.getValue(i, 0), 'margin-left': '10px', 'font-size': '150%'}).appendTo(column);
						$('<span>' + "  " + colors.getValue(i, 3)+"</span>").appendTo(column);
						row.append(column);	
					}
					j++;
				}
			}
		} else {
			break;
		}
	    table.append(row);
	}
	$('#color').append(table);
	
//	var div = $('<div></div>');
//	for (var i=0;i<colors.getNumberOfRows();i++) {
//		$('<span id=circle>'+colors.getValue(i, 3)+'</span>').css({'background': colors.getValue(i, 1), 'border': '1px solid ' + colors.getValue(i, 0), 'margin-left': '10px', 'font-size': '150%'}).appendTo(div);
//	}
//	$('#color').append('<br>');
//	$('#color').append(div);

	
	
	$('#color').append('<h4>Figurforklaring:</h4>');
	var figures = $('<div></div>');
	$('<span id=circle></span>').css({'background': 'rgba(0,0,0,0.1)', 'border': '1px dashed black', 'borderRadius': '2px'}).appendTo(figures);
	$('<span> Den mest sannsynlige slagbehandlingen.</span></br>').appendTo(figures);
	$('<span id=circle></span>').css({'background': colors.getValue(1, 1), 'border': '1px dashed ' + colors.getValue(1, 0)}).appendTo(figures);
	$('<span> Dine slagkontakter i en standard slagbehandling. Hvis du vil se detaljer om  en slik behandling, <a href="http://www.helse-midt.no/ftp/stolav/eqspublic/pasientforlop/docs/doc_22384/index.html" target="_blank">klikk her</a>.</span></br>').appendTo(figures);
	$('<span id=line></span>').appendTo(figures);
	$('<span> Viser når slaget ditt skjedde.</span></br>').appendTo(figures);
	$('#color').append(figures);
	
	if ($('input[name=stroke]:checked').val()=="stroke1") {
		$('<br><span id=circle></span>').css({'background': colors.getValue(0, 1), 'border': '1px solid ' + colors.getValue(0, 0)}).appendTo(figures);
		$('<span> Sirkler med fyll viser de kontaktene du har hatt med helsevesenet i forbindelse med slag.</span></br>').appendTo(figures);
		$('<span id=circle></span>').css({'border': '1px solid ' + colors.getValue(0, 0)}).appendTo(figures);
		$('<span> Sirkler uten fyll viser kontakter som er uavhegig av slaget.</span></br>').appendTo(figures);		
	}
}

